<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is
 * licensed under The BSD license.

 * ---
 * Copyright (c) 2009, Skalfa LLC
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, this list of conditions and
 *  the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *  the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *  - Neither the name of the Skalfa LLC nor the names of its contributors may be used to endorse or promote products
 *  derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * @author Aybat Duyshokov <duyshokov@gmail.com>
 * @package ow_plugins.contact_importer.controllers
 * @since 1.0
 */
class CONTACTIMPORTER_CTRL_Add extends OW_ActionController
{

    public function index()
    {
        if ( !empty($_POST['command']) && $_POST['command'] == 'add-to-friends' )
        {


            foreach ( $_POST['userId'] as $userId )
            {
                if ( intval($userId) == 0 )
                    continue;

                $frendsService = FRIENDS_BOL_Service::getInstance();
                $frendsService->request(OW::getUser()->getId(), $userId);
            }

            OW::getFeedback()->info(OW::getLanguage()->text('contact_importer', 'feedback_added_to_friends'));
            $this->redirect(OW::getRouter()->urlForRoute('contact-importer-invite'));
        }

        $userService = BOL_UserService::getInstance();

        $list = $this->getUsers();

        $idList = array();
        $displayNameList = array();
        $avatarUrlList = array();

        foreach ( $list as $user )
        {
            $idList[] = $user->getId();
        }

        if ( !empty($idList) )
        {
            $displayNameList = $userService->getDisplayNamesForList($idList);
            $avatarUrlList = BOL_AvatarService::getInstance()->getAvatarsUrlList($idList);
        }

        $this->assign('displayNameList', $displayNameList);
        $this->assign('avatarUrlList', $avatarUrlList);

        $this->assign('list', $list);
    }

    private function getEmails()
    {
        /* 		$a1 = array ( 'testJoin@mail.ru', 'rrrrrr@mail.ru', 'test10000@mail.ru',
          'test0000@gmail.com', 'test9999110@mail.ru', '123456667788879996@mail.ru',
          'joker@mail.ru', 'ooo@gmail.com', 'joker.OW2@gmail.com', 'test@testetset.com' );

          $a2 = array('duyshokov@gmail.com', 'ilim.aliev@gmail.com', 'duyshokov@yahoo.com');

          return array_merge($a1, $a2);
         */

        if ( empty($_SESSION['gc']) )
        {
            return array();
        }

        $user = OW::getUser();

        $key = array_search($user->getEmail(), $_SESSION['gc']);

        if ( $key )
        {
            unset($_SESSION['gc'][$key]);
        }

        return $_SESSION['gc'];
    }

    private function getUsers()
    {
        $emails = $this->getEmails();
        if ( empty($emails) )
        {
            $this->redirect(OW::getRouter()->urlForRoute('contact-importer-invite'));
        }

        $userService = BOL_UserService::getInstance();

        $userList = $userService->findListByEmailList($emails);

        $out = array();

        foreach ( $userList as $user )
        {
            $fship = FRIENDS_BOL_Service::getInstance()->findFriendship(OW::getUser()->getId(), $user->getId());

            if ( !empty($fship)
                && ( $fship->getStatus() == 'active' || ( $fship->getStatus() == 'pending' && $fship->friendId == $user->getId() ) )
            )
            {
                continue;
            }

            $out[] = $user;
        }

        if ( empty($out) )
        {
            $this->redirect(OW::getRouter()->urlForRoute('contact-importer-invite'));
        }

        return $out;
    }
}