<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is
 * licensed under The BSD license.

 * ---
 * Copyright (c) 2009, Skalfa LLC
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, this list of conditions and
 *  the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *  the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *  - Neither the name of the Skalfa LLC nor the names of its contributors may be used to endorse or promote products
 *  derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
$plugin = OW::getPluginManager()->getPlugin('newsfeed');

$dbPrefix = OW_DB_PREFIX;

$sql[] ="
CREATE TABLE IF NOT EXISTS `{$dbPrefix}newsfeed_action` (
  `id` int(11) NOT NULL auto_increment,
  `entityId` int(11) NOT NULL,
  `entityType` varchar(100) NOT NULL,
  `pluginKey` varchar(100) NOT NULL,
  `data` longtext NOT NULL,
  `status` varchar(20) NOT NULL default 'active',
  `createTime` int(11) NOT NULL,
  `updateTime` int(11) NOT NULL,
  `userId` int(11) NOT NULL,
  `privacy` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `entity` (`entityType`,`entityId`),
  KEY `userId` (`userId`),
  KEY `privacy` (`privacy`),
  KEY `updateTime` (`updateTime`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;";


$sql[] ="
CREATE TABLE IF NOT EXISTS `{$dbPrefix}newsfeed_action_feed` (
  `id` int(11) NOT NULL auto_increment,
  `feedType` varchar(100) NOT NULL,
  `feedId` int(11) NOT NULL,
  `actionId` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `feedId` (`feedType`,`feedId`,`actionId`),
  KEY `actionId` (`actionId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;";

$sql[] ="
CREATE TABLE IF NOT EXISTS `{$dbPrefix}newsfeed_follow` (
  `id` int(11) NOT NULL auto_increment,
  `feedId` int(11) NOT NULL,
  `feedType` varchar(100) NOT NULL,
  `userId` int(11) NOT NULL,
  `followTime` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `feedId` (`feedType`,`feedId`,`userId`),
  KEY `userId` (`userId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;";

$sql[] ="
CREATE TABLE IF NOT EXISTS `{$dbPrefix}newsfeed_like` (
  `id` int(11) NOT NULL auto_increment,
  `entityType` varchar(100) NOT NULL,
  `entityId` int(11) NOT NULL,
  `userId` int(11) NOT NULL,
  `timeStamp` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `entityType` (`entityType`,`entityId`,`userId`),
  KEY `userId` (`userId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;";

$sql[] ="
CREATE TABLE IF NOT EXISTS `{$dbPrefix}newsfeed_status` (
  `id` int(11) NOT NULL auto_increment,
  `feedType` varchar(100) NOT NULL,
  `feedId` int(11) NOT NULL,
  `timeStamp` int(11) NOT NULL,
  `status` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `feedType` (`feedType`,`feedId`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;";

foreach ( $sql as $query )
{
    OW::getDbo()->query($query);
}

BOL_LanguageService::getInstance()->importPrefixFromZip($plugin->getRootDir() . 'langs.zip', 'newsfeed');

OW::getConfig()->addConfig('newsfeed', 'allow_likes', 1, 'Allow Likes');
OW::getConfig()->addConfig('newsfeed', 'comments_count', 3, 'Count of comments');

OW::getPluginManager()->addPluginSettingsRouteName('newsfeed', 'newsfeed_admin_settings');

$authService = BOL_AuthorizationService::getInstance();

$group = new BOL_AuthorizationGroup();
$group->name = 'newsfeed';
$group->moderated = true;

$authService->addGroup($group, array(
    'en' => 'Newsfeed'
));

$authAction = new BOL_AuthorizationAction();
$authAction->groupId = $group->id;
$authAction->name = 'add_comment';
$authAction->availableForGuest = false;

$authService->addAction($authAction, array(
    'en' => 'Allow comments'
));

$authRoleList = $authService->getRoleList();

foreach ( $authRoleList as $role )
{
    $authService->grantActionListToRole($role, array($authAction));
}
