<?php
class BASE_CTRL_MediaPanel extends OW_ActionController
{
	public function __construct()
	{
		$this->assign('elId', $_GET['eid']);
		if(!OW::getUser()->isAuthenticated())
		{
		    $this->setVisible(false);
		    return;
		}
	}
	
	public function index($params)
	{
		OW::getDocument()->getMasterPage()->setTemplate( OW::getThemeManager()->getMasterPageTemplate(OW_MasterPage::TEMPLATE_BLANK) );

		$type = $params['type'];
		
		$plugin = $params['plugin'];

		$this->addComponent('menu', $this->getMenu($plugin));

		$form = new UploadImageForm();

		if(!empty($_POST['command']) && $_POST['command'] == 'image-upload' )
		{
			UploadImageForm::process($plugin);
		}

		$this->assign('maxSize', OW::getConfig()->getValue('base', 'tf_max_pic_size'));

		$this->addForm( $form );
	}

	public function gallery($params)
	{

	    if(!empty($_POST))
	    {
	        $userId = OW::getUser()->getId();
	        if(empty($userId))
	        {
                throw new Exception('Guests can\'t view this page');
	        }

	        $imgId = intval($_POST['img-id']);

            if($imgId < 0)
            {
                exit();
            }

	        BOL_MediaPanelService::getInstance()->deleteById( $imgId );

	        OW::getFeedback()->info(OW::getLanguage()->text('base', 'media_panel_file_deleted'));
	        $this->redirect();
	    }

		if(!empty($_GET['bb']))
		{
			$dl = '['; $dr = ']';
		}
		else
		{
			$dl = '<'; $dr = '>';
		}

		$this->assign('dl', $dl);
		$this->assign('dr', $dr);

        $sel_start = 0;

        if ( !empty($_GET['sel_start']) )
        {
            $sel_start = $_GET['sel_start'];
        }

        $this->assign('sel_start', $sel_start);

		OW::getDocument()->getMasterPage()->setTemplate( OW::getThemeManager()->getMasterPageTemplate(OW_MasterPage::TEMPLATE_BLANK) );
		
		$plugin = $params['plugin'];
		$type = $params['type'];
		$id = empty($params['id'])? null: $params['id'];

		$this->addComponent('menu', $this->getMenu($plugin));
		
		$service = BOL_MediaPanelService::getInstance();
		
		switch($type)
		{
			case 'image':
				$list = $service->findGalleryImages($plugin, OW::getUser()->getId(), 0, 10);
				$list = array_reverse($list);
				$images = array();

				foreach($list as $img)
				{
					$images[] = array(
						'dto'=> $img,
						'data'=>$img->getData(),
						'url'=>OW::getPluginManager()->getPlugin('base')->getUserFilesUrl(),
						'sel'=> !empty($params['id']) && $img->getId() == $params['id'],
					);
				}
				
				$this->assign('images', $images);
				$this->setTemplate(OW::getPluginManager()->getPlugin('base')->getViewDir().'controllers/mp_gallery_images.html');

				break;
		}
	}

	public function fromUrl($params)
	{
		$plugin = $params['plugin'];

		$this->addComponent('menu', $this->getMenu($plugin));

		if(!empty($_GET['bb']))
		{
			$dl = '['; $dr = ']';
		}
		else
		{
			$dl = '<'; $dr = '>';
		}

		$this->assign('dl', $dl);
		$this->assign('dr', $dr);

		$this->assign('eid', $_GET['eid']);
        $this->assign('sel_start', $_GET['sel_start']);
		
		OW::getDocument()->getMasterPage()->setTemplate( OW::getThemeManager()->getMasterPageTemplate(OW_MasterPage::TEMPLATE_BLANK) );
		$this->setTemplate(OW::getPluginManager()->getPlugin('base')->getViewDir().'controllers/mp_image_from_url.html');
	}

	private function getMenu($plugin)
	{
		$language = OW::getLanguage()->getInstance();

		$isBB = !empty($_GET['bb']);

		$item[0] = new BASE_MenuItem();

		$item[0]->setLabel( OW::getLanguage()->text('base', 'upload' ) )
				->setOrder(0)
				->setKey(0)
				->setUrl( OW::getRouter()->urlFor('BASE_CTRL_MediaPanel', 'index', array( 'plugin'=>$plugin, 'type'=>'image' )) ."?eid={$_GET['eid']}".( $isBB ? '&bb=y':'' ).($_GET['sel_start'] ? '&sel_start='.$_GET['sel_start'] : '&sel_start=0') );

		$item[1] = new BASE_MenuItem();

		$item[1]->setLabel( OW::getLanguage()->text('base', 'tf_img_from_url') )
				->setOrder(1)
				->setKey(1)
				->setUrl( OW::getRouter()->urlFor('BASE_CTRL_MediaPanel', 'fromUrl', array('plugin'=>$plugin, 'type'=>'image'))."?eid={$_GET['eid']}".( $isBB ? '&bb=y':'' ).($_GET['sel_start'] ? '&sel_start='.$_GET['sel_start'] : '&sel_start=0') );
				
		$item[2] = new BASE_MenuItem();

		$count = BOL_MediaPanelService::getInstance()->countGalleryImages( $plugin, OW::getUser()->getId() );
		
		$item[2]->setLabel( OW::getLanguage()->text('base','tf_img_gal') . ( 
		    $count == 0 ? '': " ({$count})" ) )
				->setOrder(2)
				->setKey(2)
				->setActive( strstr(OW::getRouter()->getBaseUrl().OW::getRouter()->getUri(), 'gallery') !== false )
				->setUrl( OW::getRouter()->urlFor('BASE_CTRL_MediaPanel', 'gallery', array('plugin'=>$plugin, 'type'=>'image'))."?eid={$_GET['eid']}".( $isBB ? '&bb=y':'' ).($_GET['sel_start'] ? '&sel_start='.$_GET['sel_start'] : '&sel_start=0') );

		return new BASE_CMP_ContentMenu($item);
	}

}

class UploadImageForm extends Form
{
	public function __construct()
	{
		parent::__construct('image-upload');

		$this->setEnctype('multipart/form-data');

		$hidden = new HiddenField('command');

		$hidden->setValue('image-upload');

		$this->addElement($hidden);

		$hiddenMaxSize = new HiddenField('MAX_FILE_SIZE');

		$hiddenMaxSize->setValue( intval(OW::getConfig()->getValue('base', 'tf_max_pic_size')) * 1000000 );

		$fileInput = new FileField('file'); 

		$fileInput->setLabel(OW::getLanguage()->text('base','tf_img_choose_file'))->setRequired(true);

		$this->addElement($fileInput);

		$submit = new Submit('submit');

		$submit->setValue(OW::getLanguage()->text( 'base', 'upload' ));

		$this->addElement($submit);

		return $this;
	}

	public static function process($plugin)
	{
		$uploaddir = OW::getPluginManager()->getPlugin('base')->getUserFilesDir(); 
		$name = $_FILES['file']['name'];

		$tmpname = $_FILES['file']['tmp_name'];

		$image = new UTIL_Image($tmpname);

		$height = $image->getHeight();

		$width = $image->getWidth();

		$id = BOL_MediaPanelService::getInstance()->add($plugin, 'image', OW::getUser()->getId(), array('name'=>$name, 'height'=>$height, 'width'=>$width));

		$image
		    ->saveImage($uploaddir ."{$id}-$name");

		$storage = OW::getStorage();

		move_uploaded_file( $tmpname, $uploaddir . $tmpname );

		@unlink($uploaddir . $tmpname);

		$storage->copyFile($uploaddir . $tmpname, $uploaddir . $id.'-'.$name);

		$isBB = !empty($_GET['bb']);
        $sel_start = '&sel_start='.( $_GET['sel_start'] ? $_GET['sel_start'] : '0' );

		OW::getApplication()->redirect( OW::getRouter()->urlFor('BASE_CTRL_MediaPanel', 'gallery', array('plugin'=>$plugin, 'type'=>'image', 'id'=>$id))."?eid={$_GET['eid']}".($isBB? '&bb=y':'').$sel_start );
	}
}